// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: reservemodule/reservemodule.proto

package openfmb.reservemodule;

/**
 * <pre>
 * Reserve availability profile
 * </pre>
 *
 * Protobuf type {@code reservemodule.ReserveAvailabilityProfile}
 */
public final class ReserveAvailabilityProfile extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:reservemodule.ReserveAvailabilityProfile)
    ReserveAvailabilityProfileOrBuilder {
private static final long serialVersionUID = 0L;
  // Use ReserveAvailabilityProfile.newBuilder() to construct.
  private ReserveAvailabilityProfile(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private ReserveAvailabilityProfile() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new ReserveAvailabilityProfile();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.reservemodule.Reservemodule.internal_static_reservemodule_ReserveAvailabilityProfile_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.reservemodule.Reservemodule.internal_static_reservemodule_ReserveAvailabilityProfile_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.reservemodule.ReserveAvailabilityProfile.class, openfmb.reservemodule.ReserveAvailabilityProfile.Builder.class);
  }

  public static final int CONTROLMESSAGEINFO_FIELD_NUMBER = 1;
  private openfmb.commonmodule.ControlMessageInfo controlMessageInfo_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the controlMessageInfo field is set.
   */
  @java.lang.Override
  public boolean hasControlMessageInfo() {
    return controlMessageInfo_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   * @return The controlMessageInfo.
   */
  @java.lang.Override
  public openfmb.commonmodule.ControlMessageInfo getControlMessageInfo() {
    return controlMessageInfo_ == null ? openfmb.commonmodule.ControlMessageInfo.getDefaultInstance() : controlMessageInfo_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ControlMessageInfoOrBuilder getControlMessageInfoOrBuilder() {
    return controlMessageInfo_ == null ? openfmb.commonmodule.ControlMessageInfo.getDefaultInstance() : controlMessageInfo_;
  }

  public static final int ALLOCATEDMARGIN_FIELD_NUMBER = 2;
  private openfmb.reservemodule.AllocatedMargin allocatedMargin_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.AllocatedMargin allocatedMargin = 2;</code>
   * @return Whether the allocatedMargin field is set.
   */
  @java.lang.Override
  public boolean hasAllocatedMargin() {
    return allocatedMargin_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.AllocatedMargin allocatedMargin = 2;</code>
   * @return The allocatedMargin.
   */
  @java.lang.Override
  public openfmb.reservemodule.AllocatedMargin getAllocatedMargin() {
    return allocatedMargin_ == null ? openfmb.reservemodule.AllocatedMargin.getDefaultInstance() : allocatedMargin_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.AllocatedMargin allocatedMargin = 2;</code>
   */
  @java.lang.Override
  public openfmb.reservemodule.AllocatedMarginOrBuilder getAllocatedMarginOrBuilder() {
    return allocatedMargin_ == null ? openfmb.reservemodule.AllocatedMargin.getDefaultInstance() : allocatedMargin_;
  }

  public static final int REQUESTERCIRCUITSEGMENTSERVICE_FIELD_NUMBER = 3;
  private openfmb.commonmodule.ApplicationSystem requesterCircuitSegmentService_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ApplicationSystem requesterCircuitSegmentService = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the requesterCircuitSegmentService field is set.
   */
  @java.lang.Override
  public boolean hasRequesterCircuitSegmentService() {
    return requesterCircuitSegmentService_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ApplicationSystem requesterCircuitSegmentService = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The requesterCircuitSegmentService.
   */
  @java.lang.Override
  public openfmb.commonmodule.ApplicationSystem getRequesterCircuitSegmentService() {
    return requesterCircuitSegmentService_ == null ? openfmb.commonmodule.ApplicationSystem.getDefaultInstance() : requesterCircuitSegmentService_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ApplicationSystem requesterCircuitSegmentService = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ApplicationSystemOrBuilder getRequesterCircuitSegmentServiceOrBuilder() {
    return requesterCircuitSegmentService_ == null ? openfmb.commonmodule.ApplicationSystem.getDefaultInstance() : requesterCircuitSegmentService_;
  }

  public static final int RESERVEAVAILABILITY_FIELD_NUMBER = 4;
  private openfmb.reservemodule.ReserveAvailability reserveAvailability_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveAvailability reserveAvailability = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the reserveAvailability field is set.
   */
  @java.lang.Override
  public boolean hasReserveAvailability() {
    return reserveAvailability_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveAvailability reserveAvailability = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The reserveAvailability.
   */
  @java.lang.Override
  public openfmb.reservemodule.ReserveAvailability getReserveAvailability() {
    return reserveAvailability_ == null ? openfmb.reservemodule.ReserveAvailability.getDefaultInstance() : reserveAvailability_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.reservemodule.ReserveAvailability reserveAvailability = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.reservemodule.ReserveAvailabilityOrBuilder getReserveAvailabilityOrBuilder() {
    return reserveAvailability_ == null ? openfmb.reservemodule.ReserveAvailability.getDefaultInstance() : reserveAvailability_;
  }

  public static final int RESPONDERCIRCUITSEGMENTSERVICE_FIELD_NUMBER = 5;
  private openfmb.commonmodule.ApplicationSystem responderCircuitSegmentService_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ApplicationSystem responderCircuitSegmentService = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the responderCircuitSegmentService field is set.
   */
  @java.lang.Override
  public boolean hasResponderCircuitSegmentService() {
    return responderCircuitSegmentService_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ApplicationSystem responderCircuitSegmentService = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The responderCircuitSegmentService.
   */
  @java.lang.Override
  public openfmb.commonmodule.ApplicationSystem getResponderCircuitSegmentService() {
    return responderCircuitSegmentService_ == null ? openfmb.commonmodule.ApplicationSystem.getDefaultInstance() : responderCircuitSegmentService_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ApplicationSystem responderCircuitSegmentService = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ApplicationSystemOrBuilder getResponderCircuitSegmentServiceOrBuilder() {
    return responderCircuitSegmentService_ == null ? openfmb.commonmodule.ApplicationSystem.getDefaultInstance() : responderCircuitSegmentService_;
  }

  public static final int TIEPOINT_FIELD_NUMBER = 6;
  private openfmb.commonmodule.ConductingEquipment tiePoint_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ConductingEquipment tiePoint = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the tiePoint field is set.
   */
  @java.lang.Override
  public boolean hasTiePoint() {
    return tiePoint_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ConductingEquipment tiePoint = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The tiePoint.
   */
  @java.lang.Override
  public openfmb.commonmodule.ConductingEquipment getTiePoint() {
    return tiePoint_ == null ? openfmb.commonmodule.ConductingEquipment.getDefaultInstance() : tiePoint_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ConductingEquipment tiePoint = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ConductingEquipmentOrBuilder getTiePointOrBuilder() {
    return tiePoint_ == null ? openfmb.commonmodule.ConductingEquipment.getDefaultInstance() : tiePoint_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (controlMessageInfo_ != null) {
      output.writeMessage(1, getControlMessageInfo());
    }
    if (allocatedMargin_ != null) {
      output.writeMessage(2, getAllocatedMargin());
    }
    if (requesterCircuitSegmentService_ != null) {
      output.writeMessage(3, getRequesterCircuitSegmentService());
    }
    if (reserveAvailability_ != null) {
      output.writeMessage(4, getReserveAvailability());
    }
    if (responderCircuitSegmentService_ != null) {
      output.writeMessage(5, getResponderCircuitSegmentService());
    }
    if (tiePoint_ != null) {
      output.writeMessage(6, getTiePoint());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (controlMessageInfo_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getControlMessageInfo());
    }
    if (allocatedMargin_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getAllocatedMargin());
    }
    if (requesterCircuitSegmentService_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getRequesterCircuitSegmentService());
    }
    if (reserveAvailability_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getReserveAvailability());
    }
    if (responderCircuitSegmentService_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getResponderCircuitSegmentService());
    }
    if (tiePoint_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(6, getTiePoint());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.reservemodule.ReserveAvailabilityProfile)) {
      return super.equals(obj);
    }
    openfmb.reservemodule.ReserveAvailabilityProfile other = (openfmb.reservemodule.ReserveAvailabilityProfile) obj;

    if (hasControlMessageInfo() != other.hasControlMessageInfo()) return false;
    if (hasControlMessageInfo()) {
      if (!getControlMessageInfo()
          .equals(other.getControlMessageInfo())) return false;
    }
    if (hasAllocatedMargin() != other.hasAllocatedMargin()) return false;
    if (hasAllocatedMargin()) {
      if (!getAllocatedMargin()
          .equals(other.getAllocatedMargin())) return false;
    }
    if (hasRequesterCircuitSegmentService() != other.hasRequesterCircuitSegmentService()) return false;
    if (hasRequesterCircuitSegmentService()) {
      if (!getRequesterCircuitSegmentService()
          .equals(other.getRequesterCircuitSegmentService())) return false;
    }
    if (hasReserveAvailability() != other.hasReserveAvailability()) return false;
    if (hasReserveAvailability()) {
      if (!getReserveAvailability()
          .equals(other.getReserveAvailability())) return false;
    }
    if (hasResponderCircuitSegmentService() != other.hasResponderCircuitSegmentService()) return false;
    if (hasResponderCircuitSegmentService()) {
      if (!getResponderCircuitSegmentService()
          .equals(other.getResponderCircuitSegmentService())) return false;
    }
    if (hasTiePoint() != other.hasTiePoint()) return false;
    if (hasTiePoint()) {
      if (!getTiePoint()
          .equals(other.getTiePoint())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasControlMessageInfo()) {
      hash = (37 * hash) + CONTROLMESSAGEINFO_FIELD_NUMBER;
      hash = (53 * hash) + getControlMessageInfo().hashCode();
    }
    if (hasAllocatedMargin()) {
      hash = (37 * hash) + ALLOCATEDMARGIN_FIELD_NUMBER;
      hash = (53 * hash) + getAllocatedMargin().hashCode();
    }
    if (hasRequesterCircuitSegmentService()) {
      hash = (37 * hash) + REQUESTERCIRCUITSEGMENTSERVICE_FIELD_NUMBER;
      hash = (53 * hash) + getRequesterCircuitSegmentService().hashCode();
    }
    if (hasReserveAvailability()) {
      hash = (37 * hash) + RESERVEAVAILABILITY_FIELD_NUMBER;
      hash = (53 * hash) + getReserveAvailability().hashCode();
    }
    if (hasResponderCircuitSegmentService()) {
      hash = (37 * hash) + RESPONDERCIRCUITSEGMENTSERVICE_FIELD_NUMBER;
      hash = (53 * hash) + getResponderCircuitSegmentService().hashCode();
    }
    if (hasTiePoint()) {
      hash = (37 * hash) + TIEPOINT_FIELD_NUMBER;
      hash = (53 * hash) + getTiePoint().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.reservemodule.ReserveAvailabilityProfile parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.reservemodule.ReserveAvailabilityProfile parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.reservemodule.ReserveAvailabilityProfile parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.reservemodule.ReserveAvailabilityProfile parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.reservemodule.ReserveAvailabilityProfile parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.reservemodule.ReserveAvailabilityProfile parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.reservemodule.ReserveAvailabilityProfile parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.reservemodule.ReserveAvailabilityProfile parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.reservemodule.ReserveAvailabilityProfile parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.reservemodule.ReserveAvailabilityProfile parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.reservemodule.ReserveAvailabilityProfile parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.reservemodule.ReserveAvailabilityProfile parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.reservemodule.ReserveAvailabilityProfile prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Reserve availability profile
   * </pre>
   *
   * Protobuf type {@code reservemodule.ReserveAvailabilityProfile}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:reservemodule.ReserveAvailabilityProfile)
      openfmb.reservemodule.ReserveAvailabilityProfileOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.reservemodule.Reservemodule.internal_static_reservemodule_ReserveAvailabilityProfile_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.reservemodule.Reservemodule.internal_static_reservemodule_ReserveAvailabilityProfile_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.reservemodule.ReserveAvailabilityProfile.class, openfmb.reservemodule.ReserveAvailabilityProfile.Builder.class);
    }

    // Construct using openfmb.reservemodule.ReserveAvailabilityProfile.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      controlMessageInfo_ = null;
      if (controlMessageInfoBuilder_ != null) {
        controlMessageInfoBuilder_.dispose();
        controlMessageInfoBuilder_ = null;
      }
      allocatedMargin_ = null;
      if (allocatedMarginBuilder_ != null) {
        allocatedMarginBuilder_.dispose();
        allocatedMarginBuilder_ = null;
      }
      requesterCircuitSegmentService_ = null;
      if (requesterCircuitSegmentServiceBuilder_ != null) {
        requesterCircuitSegmentServiceBuilder_.dispose();
        requesterCircuitSegmentServiceBuilder_ = null;
      }
      reserveAvailability_ = null;
      if (reserveAvailabilityBuilder_ != null) {
        reserveAvailabilityBuilder_.dispose();
        reserveAvailabilityBuilder_ = null;
      }
      responderCircuitSegmentService_ = null;
      if (responderCircuitSegmentServiceBuilder_ != null) {
        responderCircuitSegmentServiceBuilder_.dispose();
        responderCircuitSegmentServiceBuilder_ = null;
      }
      tiePoint_ = null;
      if (tiePointBuilder_ != null) {
        tiePointBuilder_.dispose();
        tiePointBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.reservemodule.Reservemodule.internal_static_reservemodule_ReserveAvailabilityProfile_descriptor;
    }

    @java.lang.Override
    public openfmb.reservemodule.ReserveAvailabilityProfile getDefaultInstanceForType() {
      return openfmb.reservemodule.ReserveAvailabilityProfile.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.reservemodule.ReserveAvailabilityProfile build() {
      openfmb.reservemodule.ReserveAvailabilityProfile result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.reservemodule.ReserveAvailabilityProfile buildPartial() {
      openfmb.reservemodule.ReserveAvailabilityProfile result = new openfmb.reservemodule.ReserveAvailabilityProfile(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.reservemodule.ReserveAvailabilityProfile result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.controlMessageInfo_ = controlMessageInfoBuilder_ == null
            ? controlMessageInfo_
            : controlMessageInfoBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.allocatedMargin_ = allocatedMarginBuilder_ == null
            ? allocatedMargin_
            : allocatedMarginBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.requesterCircuitSegmentService_ = requesterCircuitSegmentServiceBuilder_ == null
            ? requesterCircuitSegmentService_
            : requesterCircuitSegmentServiceBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.reserveAvailability_ = reserveAvailabilityBuilder_ == null
            ? reserveAvailability_
            : reserveAvailabilityBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.responderCircuitSegmentService_ = responderCircuitSegmentServiceBuilder_ == null
            ? responderCircuitSegmentService_
            : responderCircuitSegmentServiceBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000020) != 0)) {
        result.tiePoint_ = tiePointBuilder_ == null
            ? tiePoint_
            : tiePointBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.reservemodule.ReserveAvailabilityProfile) {
        return mergeFrom((openfmb.reservemodule.ReserveAvailabilityProfile)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.reservemodule.ReserveAvailabilityProfile other) {
      if (other == openfmb.reservemodule.ReserveAvailabilityProfile.getDefaultInstance()) return this;
      if (other.hasControlMessageInfo()) {
        mergeControlMessageInfo(other.getControlMessageInfo());
      }
      if (other.hasAllocatedMargin()) {
        mergeAllocatedMargin(other.getAllocatedMargin());
      }
      if (other.hasRequesterCircuitSegmentService()) {
        mergeRequesterCircuitSegmentService(other.getRequesterCircuitSegmentService());
      }
      if (other.hasReserveAvailability()) {
        mergeReserveAvailability(other.getReserveAvailability());
      }
      if (other.hasResponderCircuitSegmentService()) {
        mergeResponderCircuitSegmentService(other.getResponderCircuitSegmentService());
      }
      if (other.hasTiePoint()) {
        mergeTiePoint(other.getTiePoint());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getControlMessageInfoFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getAllocatedMarginFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getRequesterCircuitSegmentServiceFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getReserveAvailabilityFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getResponderCircuitSegmentServiceFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            case 50: {
              input.readMessage(
                  getTiePointFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000020;
              break;
            } // case 50
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.ControlMessageInfo controlMessageInfo_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ControlMessageInfo, openfmb.commonmodule.ControlMessageInfo.Builder, openfmb.commonmodule.ControlMessageInfoOrBuilder> controlMessageInfoBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the controlMessageInfo field is set.
     */
    public boolean hasControlMessageInfo() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     * @return The controlMessageInfo.
     */
    public openfmb.commonmodule.ControlMessageInfo getControlMessageInfo() {
      if (controlMessageInfoBuilder_ == null) {
        return controlMessageInfo_ == null ? openfmb.commonmodule.ControlMessageInfo.getDefaultInstance() : controlMessageInfo_;
      } else {
        return controlMessageInfoBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setControlMessageInfo(openfmb.commonmodule.ControlMessageInfo value) {
      if (controlMessageInfoBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        controlMessageInfo_ = value;
      } else {
        controlMessageInfoBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setControlMessageInfo(
        openfmb.commonmodule.ControlMessageInfo.Builder builderForValue) {
      if (controlMessageInfoBuilder_ == null) {
        controlMessageInfo_ = builderForValue.build();
      } else {
        controlMessageInfoBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeControlMessageInfo(openfmb.commonmodule.ControlMessageInfo value) {
      if (controlMessageInfoBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          controlMessageInfo_ != null &&
          controlMessageInfo_ != openfmb.commonmodule.ControlMessageInfo.getDefaultInstance()) {
          getControlMessageInfoBuilder().mergeFrom(value);
        } else {
          controlMessageInfo_ = value;
        }
      } else {
        controlMessageInfoBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearControlMessageInfo() {
      bitField0_ = (bitField0_ & ~0x00000001);
      controlMessageInfo_ = null;
      if (controlMessageInfoBuilder_ != null) {
        controlMessageInfoBuilder_.dispose();
        controlMessageInfoBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ControlMessageInfo.Builder getControlMessageInfoBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getControlMessageInfoFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ControlMessageInfoOrBuilder getControlMessageInfoOrBuilder() {
      if (controlMessageInfoBuilder_ != null) {
        return controlMessageInfoBuilder_.getMessageOrBuilder();
      } else {
        return controlMessageInfo_ == null ?
            openfmb.commonmodule.ControlMessageInfo.getDefaultInstance() : controlMessageInfo_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlMessageInfo controlMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ControlMessageInfo, openfmb.commonmodule.ControlMessageInfo.Builder, openfmb.commonmodule.ControlMessageInfoOrBuilder> 
        getControlMessageInfoFieldBuilder() {
      if (controlMessageInfoBuilder_ == null) {
        controlMessageInfoBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ControlMessageInfo, openfmb.commonmodule.ControlMessageInfo.Builder, openfmb.commonmodule.ControlMessageInfoOrBuilder>(
                getControlMessageInfo(),
                getParentForChildren(),
                isClean());
        controlMessageInfo_ = null;
      }
      return controlMessageInfoBuilder_;
    }

    private openfmb.reservemodule.AllocatedMargin allocatedMargin_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.reservemodule.AllocatedMargin, openfmb.reservemodule.AllocatedMargin.Builder, openfmb.reservemodule.AllocatedMarginOrBuilder> allocatedMarginBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.AllocatedMargin allocatedMargin = 2;</code>
     * @return Whether the allocatedMargin field is set.
     */
    public boolean hasAllocatedMargin() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.AllocatedMargin allocatedMargin = 2;</code>
     * @return The allocatedMargin.
     */
    public openfmb.reservemodule.AllocatedMargin getAllocatedMargin() {
      if (allocatedMarginBuilder_ == null) {
        return allocatedMargin_ == null ? openfmb.reservemodule.AllocatedMargin.getDefaultInstance() : allocatedMargin_;
      } else {
        return allocatedMarginBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.AllocatedMargin allocatedMargin = 2;</code>
     */
    public Builder setAllocatedMargin(openfmb.reservemodule.AllocatedMargin value) {
      if (allocatedMarginBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        allocatedMargin_ = value;
      } else {
        allocatedMarginBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.AllocatedMargin allocatedMargin = 2;</code>
     */
    public Builder setAllocatedMargin(
        openfmb.reservemodule.AllocatedMargin.Builder builderForValue) {
      if (allocatedMarginBuilder_ == null) {
        allocatedMargin_ = builderForValue.build();
      } else {
        allocatedMarginBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.AllocatedMargin allocatedMargin = 2;</code>
     */
    public Builder mergeAllocatedMargin(openfmb.reservemodule.AllocatedMargin value) {
      if (allocatedMarginBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          allocatedMargin_ != null &&
          allocatedMargin_ != openfmb.reservemodule.AllocatedMargin.getDefaultInstance()) {
          getAllocatedMarginBuilder().mergeFrom(value);
        } else {
          allocatedMargin_ = value;
        }
      } else {
        allocatedMarginBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.AllocatedMargin allocatedMargin = 2;</code>
     */
    public Builder clearAllocatedMargin() {
      bitField0_ = (bitField0_ & ~0x00000002);
      allocatedMargin_ = null;
      if (allocatedMarginBuilder_ != null) {
        allocatedMarginBuilder_.dispose();
        allocatedMarginBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.AllocatedMargin allocatedMargin = 2;</code>
     */
    public openfmb.reservemodule.AllocatedMargin.Builder getAllocatedMarginBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getAllocatedMarginFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.AllocatedMargin allocatedMargin = 2;</code>
     */
    public openfmb.reservemodule.AllocatedMarginOrBuilder getAllocatedMarginOrBuilder() {
      if (allocatedMarginBuilder_ != null) {
        return allocatedMarginBuilder_.getMessageOrBuilder();
      } else {
        return allocatedMargin_ == null ?
            openfmb.reservemodule.AllocatedMargin.getDefaultInstance() : allocatedMargin_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.AllocatedMargin allocatedMargin = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.reservemodule.AllocatedMargin, openfmb.reservemodule.AllocatedMargin.Builder, openfmb.reservemodule.AllocatedMarginOrBuilder> 
        getAllocatedMarginFieldBuilder() {
      if (allocatedMarginBuilder_ == null) {
        allocatedMarginBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.reservemodule.AllocatedMargin, openfmb.reservemodule.AllocatedMargin.Builder, openfmb.reservemodule.AllocatedMarginOrBuilder>(
                getAllocatedMargin(),
                getParentForChildren(),
                isClean());
        allocatedMargin_ = null;
      }
      return allocatedMarginBuilder_;
    }

    private openfmb.commonmodule.ApplicationSystem requesterCircuitSegmentService_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ApplicationSystem, openfmb.commonmodule.ApplicationSystem.Builder, openfmb.commonmodule.ApplicationSystemOrBuilder> requesterCircuitSegmentServiceBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem requesterCircuitSegmentService = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the requesterCircuitSegmentService field is set.
     */
    public boolean hasRequesterCircuitSegmentService() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem requesterCircuitSegmentService = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The requesterCircuitSegmentService.
     */
    public openfmb.commonmodule.ApplicationSystem getRequesterCircuitSegmentService() {
      if (requesterCircuitSegmentServiceBuilder_ == null) {
        return requesterCircuitSegmentService_ == null ? openfmb.commonmodule.ApplicationSystem.getDefaultInstance() : requesterCircuitSegmentService_;
      } else {
        return requesterCircuitSegmentServiceBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem requesterCircuitSegmentService = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setRequesterCircuitSegmentService(openfmb.commonmodule.ApplicationSystem value) {
      if (requesterCircuitSegmentServiceBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        requesterCircuitSegmentService_ = value;
      } else {
        requesterCircuitSegmentServiceBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem requesterCircuitSegmentService = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setRequesterCircuitSegmentService(
        openfmb.commonmodule.ApplicationSystem.Builder builderForValue) {
      if (requesterCircuitSegmentServiceBuilder_ == null) {
        requesterCircuitSegmentService_ = builderForValue.build();
      } else {
        requesterCircuitSegmentServiceBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem requesterCircuitSegmentService = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeRequesterCircuitSegmentService(openfmb.commonmodule.ApplicationSystem value) {
      if (requesterCircuitSegmentServiceBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          requesterCircuitSegmentService_ != null &&
          requesterCircuitSegmentService_ != openfmb.commonmodule.ApplicationSystem.getDefaultInstance()) {
          getRequesterCircuitSegmentServiceBuilder().mergeFrom(value);
        } else {
          requesterCircuitSegmentService_ = value;
        }
      } else {
        requesterCircuitSegmentServiceBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem requesterCircuitSegmentService = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearRequesterCircuitSegmentService() {
      bitField0_ = (bitField0_ & ~0x00000004);
      requesterCircuitSegmentService_ = null;
      if (requesterCircuitSegmentServiceBuilder_ != null) {
        requesterCircuitSegmentServiceBuilder_.dispose();
        requesterCircuitSegmentServiceBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem requesterCircuitSegmentService = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ApplicationSystem.Builder getRequesterCircuitSegmentServiceBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getRequesterCircuitSegmentServiceFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem requesterCircuitSegmentService = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ApplicationSystemOrBuilder getRequesterCircuitSegmentServiceOrBuilder() {
      if (requesterCircuitSegmentServiceBuilder_ != null) {
        return requesterCircuitSegmentServiceBuilder_.getMessageOrBuilder();
      } else {
        return requesterCircuitSegmentService_ == null ?
            openfmb.commonmodule.ApplicationSystem.getDefaultInstance() : requesterCircuitSegmentService_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem requesterCircuitSegmentService = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ApplicationSystem, openfmb.commonmodule.ApplicationSystem.Builder, openfmb.commonmodule.ApplicationSystemOrBuilder> 
        getRequesterCircuitSegmentServiceFieldBuilder() {
      if (requesterCircuitSegmentServiceBuilder_ == null) {
        requesterCircuitSegmentServiceBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ApplicationSystem, openfmb.commonmodule.ApplicationSystem.Builder, openfmb.commonmodule.ApplicationSystemOrBuilder>(
                getRequesterCircuitSegmentService(),
                getParentForChildren(),
                isClean());
        requesterCircuitSegmentService_ = null;
      }
      return requesterCircuitSegmentServiceBuilder_;
    }

    private openfmb.reservemodule.ReserveAvailability reserveAvailability_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.reservemodule.ReserveAvailability, openfmb.reservemodule.ReserveAvailability.Builder, openfmb.reservemodule.ReserveAvailabilityOrBuilder> reserveAvailabilityBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveAvailability reserveAvailability = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the reserveAvailability field is set.
     */
    public boolean hasReserveAvailability() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveAvailability reserveAvailability = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The reserveAvailability.
     */
    public openfmb.reservemodule.ReserveAvailability getReserveAvailability() {
      if (reserveAvailabilityBuilder_ == null) {
        return reserveAvailability_ == null ? openfmb.reservemodule.ReserveAvailability.getDefaultInstance() : reserveAvailability_;
      } else {
        return reserveAvailabilityBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveAvailability reserveAvailability = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setReserveAvailability(openfmb.reservemodule.ReserveAvailability value) {
      if (reserveAvailabilityBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        reserveAvailability_ = value;
      } else {
        reserveAvailabilityBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveAvailability reserveAvailability = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setReserveAvailability(
        openfmb.reservemodule.ReserveAvailability.Builder builderForValue) {
      if (reserveAvailabilityBuilder_ == null) {
        reserveAvailability_ = builderForValue.build();
      } else {
        reserveAvailabilityBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveAvailability reserveAvailability = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeReserveAvailability(openfmb.reservemodule.ReserveAvailability value) {
      if (reserveAvailabilityBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          reserveAvailability_ != null &&
          reserveAvailability_ != openfmb.reservemodule.ReserveAvailability.getDefaultInstance()) {
          getReserveAvailabilityBuilder().mergeFrom(value);
        } else {
          reserveAvailability_ = value;
        }
      } else {
        reserveAvailabilityBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveAvailability reserveAvailability = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearReserveAvailability() {
      bitField0_ = (bitField0_ & ~0x00000008);
      reserveAvailability_ = null;
      if (reserveAvailabilityBuilder_ != null) {
        reserveAvailabilityBuilder_.dispose();
        reserveAvailabilityBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveAvailability reserveAvailability = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.reservemodule.ReserveAvailability.Builder getReserveAvailabilityBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getReserveAvailabilityFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveAvailability reserveAvailability = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.reservemodule.ReserveAvailabilityOrBuilder getReserveAvailabilityOrBuilder() {
      if (reserveAvailabilityBuilder_ != null) {
        return reserveAvailabilityBuilder_.getMessageOrBuilder();
      } else {
        return reserveAvailability_ == null ?
            openfmb.reservemodule.ReserveAvailability.getDefaultInstance() : reserveAvailability_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.reservemodule.ReserveAvailability reserveAvailability = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.reservemodule.ReserveAvailability, openfmb.reservemodule.ReserveAvailability.Builder, openfmb.reservemodule.ReserveAvailabilityOrBuilder> 
        getReserveAvailabilityFieldBuilder() {
      if (reserveAvailabilityBuilder_ == null) {
        reserveAvailabilityBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.reservemodule.ReserveAvailability, openfmb.reservemodule.ReserveAvailability.Builder, openfmb.reservemodule.ReserveAvailabilityOrBuilder>(
                getReserveAvailability(),
                getParentForChildren(),
                isClean());
        reserveAvailability_ = null;
      }
      return reserveAvailabilityBuilder_;
    }

    private openfmb.commonmodule.ApplicationSystem responderCircuitSegmentService_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ApplicationSystem, openfmb.commonmodule.ApplicationSystem.Builder, openfmb.commonmodule.ApplicationSystemOrBuilder> responderCircuitSegmentServiceBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem responderCircuitSegmentService = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the responderCircuitSegmentService field is set.
     */
    public boolean hasResponderCircuitSegmentService() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem responderCircuitSegmentService = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The responderCircuitSegmentService.
     */
    public openfmb.commonmodule.ApplicationSystem getResponderCircuitSegmentService() {
      if (responderCircuitSegmentServiceBuilder_ == null) {
        return responderCircuitSegmentService_ == null ? openfmb.commonmodule.ApplicationSystem.getDefaultInstance() : responderCircuitSegmentService_;
      } else {
        return responderCircuitSegmentServiceBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem responderCircuitSegmentService = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setResponderCircuitSegmentService(openfmb.commonmodule.ApplicationSystem value) {
      if (responderCircuitSegmentServiceBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        responderCircuitSegmentService_ = value;
      } else {
        responderCircuitSegmentServiceBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem responderCircuitSegmentService = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setResponderCircuitSegmentService(
        openfmb.commonmodule.ApplicationSystem.Builder builderForValue) {
      if (responderCircuitSegmentServiceBuilder_ == null) {
        responderCircuitSegmentService_ = builderForValue.build();
      } else {
        responderCircuitSegmentServiceBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem responderCircuitSegmentService = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeResponderCircuitSegmentService(openfmb.commonmodule.ApplicationSystem value) {
      if (responderCircuitSegmentServiceBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          responderCircuitSegmentService_ != null &&
          responderCircuitSegmentService_ != openfmb.commonmodule.ApplicationSystem.getDefaultInstance()) {
          getResponderCircuitSegmentServiceBuilder().mergeFrom(value);
        } else {
          responderCircuitSegmentService_ = value;
        }
      } else {
        responderCircuitSegmentServiceBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem responderCircuitSegmentService = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearResponderCircuitSegmentService() {
      bitField0_ = (bitField0_ & ~0x00000010);
      responderCircuitSegmentService_ = null;
      if (responderCircuitSegmentServiceBuilder_ != null) {
        responderCircuitSegmentServiceBuilder_.dispose();
        responderCircuitSegmentServiceBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem responderCircuitSegmentService = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ApplicationSystem.Builder getResponderCircuitSegmentServiceBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getResponderCircuitSegmentServiceFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem responderCircuitSegmentService = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ApplicationSystemOrBuilder getResponderCircuitSegmentServiceOrBuilder() {
      if (responderCircuitSegmentServiceBuilder_ != null) {
        return responderCircuitSegmentServiceBuilder_.getMessageOrBuilder();
      } else {
        return responderCircuitSegmentService_ == null ?
            openfmb.commonmodule.ApplicationSystem.getDefaultInstance() : responderCircuitSegmentService_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ApplicationSystem responderCircuitSegmentService = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ApplicationSystem, openfmb.commonmodule.ApplicationSystem.Builder, openfmb.commonmodule.ApplicationSystemOrBuilder> 
        getResponderCircuitSegmentServiceFieldBuilder() {
      if (responderCircuitSegmentServiceBuilder_ == null) {
        responderCircuitSegmentServiceBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ApplicationSystem, openfmb.commonmodule.ApplicationSystem.Builder, openfmb.commonmodule.ApplicationSystemOrBuilder>(
                getResponderCircuitSegmentService(),
                getParentForChildren(),
                isClean());
        responderCircuitSegmentService_ = null;
      }
      return responderCircuitSegmentServiceBuilder_;
    }

    private openfmb.commonmodule.ConductingEquipment tiePoint_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ConductingEquipment, openfmb.commonmodule.ConductingEquipment.Builder, openfmb.commonmodule.ConductingEquipmentOrBuilder> tiePointBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipment tiePoint = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the tiePoint field is set.
     */
    public boolean hasTiePoint() {
      return ((bitField0_ & 0x00000020) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipment tiePoint = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The tiePoint.
     */
    public openfmb.commonmodule.ConductingEquipment getTiePoint() {
      if (tiePointBuilder_ == null) {
        return tiePoint_ == null ? openfmb.commonmodule.ConductingEquipment.getDefaultInstance() : tiePoint_;
      } else {
        return tiePointBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipment tiePoint = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setTiePoint(openfmb.commonmodule.ConductingEquipment value) {
      if (tiePointBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        tiePoint_ = value;
      } else {
        tiePointBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipment tiePoint = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setTiePoint(
        openfmb.commonmodule.ConductingEquipment.Builder builderForValue) {
      if (tiePointBuilder_ == null) {
        tiePoint_ = builderForValue.build();
      } else {
        tiePointBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipment tiePoint = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeTiePoint(openfmb.commonmodule.ConductingEquipment value) {
      if (tiePointBuilder_ == null) {
        if (((bitField0_ & 0x00000020) != 0) &&
          tiePoint_ != null &&
          tiePoint_ != openfmb.commonmodule.ConductingEquipment.getDefaultInstance()) {
          getTiePointBuilder().mergeFrom(value);
        } else {
          tiePoint_ = value;
        }
      } else {
        tiePointBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipment tiePoint = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearTiePoint() {
      bitField0_ = (bitField0_ & ~0x00000020);
      tiePoint_ = null;
      if (tiePointBuilder_ != null) {
        tiePointBuilder_.dispose();
        tiePointBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipment tiePoint = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ConductingEquipment.Builder getTiePointBuilder() {
      bitField0_ |= 0x00000020;
      onChanged();
      return getTiePointFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipment tiePoint = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ConductingEquipmentOrBuilder getTiePointOrBuilder() {
      if (tiePointBuilder_ != null) {
        return tiePointBuilder_.getMessageOrBuilder();
      } else {
        return tiePoint_ == null ?
            openfmb.commonmodule.ConductingEquipment.getDefaultInstance() : tiePoint_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ConductingEquipment tiePoint = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ConductingEquipment, openfmb.commonmodule.ConductingEquipment.Builder, openfmb.commonmodule.ConductingEquipmentOrBuilder> 
        getTiePointFieldBuilder() {
      if (tiePointBuilder_ == null) {
        tiePointBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ConductingEquipment, openfmb.commonmodule.ConductingEquipment.Builder, openfmb.commonmodule.ConductingEquipmentOrBuilder>(
                getTiePoint(),
                getParentForChildren(),
                isClean());
        tiePoint_ = null;
      }
      return tiePointBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:reservemodule.ReserveAvailabilityProfile)
  }

  // @@protoc_insertion_point(class_scope:reservemodule.ReserveAvailabilityProfile)
  private static final openfmb.reservemodule.ReserveAvailabilityProfile DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.reservemodule.ReserveAvailabilityProfile();
  }

  public static openfmb.reservemodule.ReserveAvailabilityProfile getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<ReserveAvailabilityProfile>
      PARSER = new com.google.protobuf.AbstractParser<ReserveAvailabilityProfile>() {
    @java.lang.Override
    public ReserveAvailabilityProfile parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<ReserveAvailabilityProfile> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<ReserveAvailabilityProfile> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.reservemodule.ReserveAvailabilityProfile getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

